# -*- coding: iso-8859-1 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Conector para Vimeo
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------

import urlparse,urllib2,urllib,re
import os
import socket
from xml.dom.minidom import parseString

from core import scrapertools
from core import logger
from core import config
from core import jsontools

import xbmc

# Returns an array of possible video url's from the page_url
def get_video_url( page_url , premium = False , user="" , password="", video_password="" ):
    logger.info("servers.vimeo get_video_url(page_url='%s')" % page_url)

    video_urls = []

    headers = []
    headers.append( ['User-Agent','Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'] )
    data = scrapertools.cache_page(page_url, headers=headers)

    '''
    <script>
      !function(i){if(void 0===i.vimeo||void 0===i.vimeo.clips){i.vimeo=i.vimeo||{},i.vimeo.clips=i.vimeo.clips||{};var e=new XMLHttpRequest;e.open("GET","https://player.vimeo.com/video/17555432/config?byline=0&collections=1&context=Vimeo%5CController%5CClipController.main&default_to_hd=1&outro=nothing&portrait=0&share=1&title=0&watch_trailer=0&s=978c65150109aba98f7d12200d3e8e5e6550ac59_1482329990",!0),e.onload=function(){i.vimeo.clips["17555432"]=JSON.parse(e.responseText)},e.withCredentials=!0,e.send()}}(window);
     </script>
    '''

    #url = scrapertools.find_single_match(data,'<div class="player" style="[^"]+" id="[^"]+" data-config-url="([^"]+)"')
    url = scrapertools.find_single_match(data,'e.open."GET","([^"]+)",')
    url = url.replace("&amp;","&")
    headers.append( ['Referer',page_url] )
    data = scrapertools.cache_page(url, headers=headers)
    json_object = jsontools.load_json(data)
    xbmc.log("VVVVV json_object: %s" % json_object)

    '''
    {"cdn_url":"https://f.vimeocdn.com","view":1,"request":{"files":{"hls":{"separate_av":false,"default_cdn":"level3","cdns":{"level3":{"url":"https://09-lvl3-hls.vimeocdn.com/1482237385-ad6378c6e33089a544867d917013735ac4e78856/01/3511/0/17555432/master.m3u8","origin":"level3"}},"origin":"level3"},"progressive":[{"profile":107,"width":480,"mime":"video/mp4","fps":25,"url":"https://09-lvl3-pdl.vimeocdn.com/01/3511/0/17555432/34463320.mp4?expires=1482251781&token=08b607741414fc3c21a56","cdn":"level3","quality":"480p","id":34463320,"origin":"level3","height":360}]},"lang":"es","ga_account":"UA-76641-35","ab_tests":{"cdn_switch":{"data":{"cdn_switch":false},"group":0}},"referrer":null,"cookie_domain":".vimeo.com","timestamp":1482230185,"expires":21296,"mixpanel_token":"70d46977e96e9a6dc94d325018e1a7a5","currency":"EUR","comscore_id":"14640914","session":"2198f5a56dc71c43aed156dea0b1761c1cb838861482230185","cookie":{"scaling":1,"volume":1.0,"quality":null,"hd":0,"captions":null},"build":{"player":"e67e8658","js":"2.45.2"},"urls":{"zeroclip_swf":"https://f.vimeocdn.com/p/external/zeroclipboard/ZeroClipboard.swf","js":"https://f.vimeocdn.com/p/2.45.2/js/player.es.js","proxy":"https://player.vimeo.com/static/proxy.html","flideo":"https://f.vimeocdn.com/p/flash/flideo/1.0.6/flideo.swf","three_js":"https://f.vimeocdn.com/p/external/three.rvimeo.min.js","moog":"https://f.vimeocdn.com/p/flash/moogaloop/6.4.4/moogaloop.swf?clip_id=17555432","comscore_js":"https://f.vimeocdn.com/p/external/streamsense.4.1408.29.min.js","blurr":"https://fresnel.vimeocdn.com/add/player-stats","chromeless_css":"https://f.vimeocdn.com/p/2.45.2/css/chromeless.css","vuid_js":"https://f.vimeocdn.com/js_opt/modules/utils/vuid.min.js","chromeless_js":"https://f.vimeocdn.com/p/2.45.2/js/chromeless.js","moog_js":"https://f.vimeocdn.com/p/2.45.2/js/moogaloop.js","zeroclip_js":"https://f.vimeocdn.com/p/external/zeroclipboard/ZeroClipboard-patch.js","css":"https://f.vimeocdn.com/p/2.45.2/css/player.css"},"signature":"9f0fe8fffcc2794e4240a217fef2a57d","flags":{"dnt":0,"preload_video":"metadata_on_hover","plays":1,"mixpanel":0,"webp":0,"flash_hls":0,"android_inline":0,"partials":1,"blurr":0,"autohide_controls":0},"country":"ES"},"player_url":"player.vimeo.com","video":{"allow_hd":1,"embed_code":"<iframe src=\"https://player.vimeo.com/video/17555432\" width=\"640\" height=\"480\" frameborder=\"0\" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>","default_to_hd":1,"title":"La era de la estupidez","url":"https://vimeo.com/17555432","privacy":"anybody","owner":{"account_type":"basic","name":"Tyrel Corp","img":"https://i.vimeocdn.com/portrait/1425107_60x60.jpg","url":"https://vimeo.com/user4662746","img_2x":"https://i.vimeocdn.com/portrait/1425107_120x120.jpg","id":4662746},"share_url":"https://vimeo.com/17555432","height":360,"design_version_360":null,"width":480,"embed_permission":"public","thumbs":{"960":"https://i.vimeocdn.com/video/109271343_960.jpg","640":"https://i.vimeocdn.com/video/109271343_640.jpg","base":"https://i.vimeocdn.com/video/109271343"},"fps":25.0,"duration":5324,"is_panorama":0,"id":17555432,"hd":0},"build":{"player":"e67e8658","rpc":"dev"},"embed":{"autopause":1,"color":"00adef","on_site":1,"outro":"promoted","api":3,"player_id":"","quality":null,"settings":{"fullscreen":1,"instant_sidedock":1,"byline":0,"like":1,"playbar":1,"title":0,"color":1,"branding":0,"share":1,"scaling":1,"logo":0,"collections":1,"info_on_pause":0,"watch_later":1,"portrait":0,"embed":1,"badge":0,"volume":1},"context":"Vimeo\\Controller\\ClipController.main","time":0,"email":{"text":"","confirmation":"","time":-1},"loop":0,"autoplay":0},"vimeo_url":"vimeo.com","user":{"liked":0,"account_type":"none","progress":0,"owner":0,"watch_later":0,"logged_in":0,"id":0,"mod":0}}
    '''
    files = json_object['request']['files']

    #media_url = json_object['request']['files']['h264']['hd']['url']
    media_url_m3u8 = json_object['request']['files']['hls']['cdns']['level3']['url']
    video_urls.append( [ "m3u8 [vimeo]", media_url_m3u8 ] )

    #media_url = json_object['request']['files']['h264']['sd']['url']
    media_url_mp4 = json_object['request']['files']['progressive'][0]['url']
    video_urls.append( [ ".mp4 [vimeo]", media_url_mp4 ] )

    for video_url in video_urls:
        logger.info("servers.vimeo %s - %s" % (video_url[0],video_url[1]))

    return video_urls

# Encuentra vdeos del servidor en el texto pasado
def find_videos(text):
    encontrados = set()
    devuelve = []

    #"http://player.vimeo.com/video/17555432?title=0&amp;byline=0&amp;portrait=0
    patronvideos  = 'player.vimeo.com/video/([0-9]+)'
    logger.info("servers.vimeo find_videos #"+patronvideos+"#")
    matches = re.compile(patronvideos,re.DOTALL).findall(text)

    for match in matches:
        titulo = "[vimeo]"
        url = "http://vimeo.com/"+match
        if url not in encontrados:
            logger.info("  url="+url)
            devuelve.append( [ titulo , url , 'vimeo' ] )
            encontrados.add(url)
        else:
            logger.info("  url duplicada="+url)
            

    #"http://vimeo.com/17555432
    patronvideos  = 'vimeo.com/([0-9]+)'
    logger.info("servers.vimeo find_videos #"+patronvideos+"#")
    matches = re.compile(patronvideos,re.DOTALL).findall(text)

    for match in matches:
        titulo = "[vimeo]"
        url = "http://vimeo.com/"+match
        if url not in encontrados:
            logger.info("  url="+url)
            devuelve.append( [ titulo , url , 'vimeo' ] )
            encontrados.add(url)
        else:
            logger.info("  url duplicada="+url)
            
    return devuelve
